import {demoConfig} from "./demo-config";
import "@vanillawc/wc-codemirror";

import "./script-graph";
import "./script-graph2";

import { ActionHandler } from "./script-to-graph";

import { mdiAsterisk, mdiArrowUp, mdiArrowDown } from "@mdi/js";

let index_counter = 0;
let nodes = [];

window.onload = () => {

  let src = demoConfig;

  const fullcode = document.querySelector("#fullcode");
  fullcode.mode = "yaml";
  window.setTimeout(()=> fullcode.value = jsyaml.safeDump(src), 100);

  const updateButton = document.querySelector("#updateButton");
  updateButton.addEventListener('click', () => {
    src = jsyaml.safeLoad(fullcode.value);
    index_counter = 0;
    nodes = [];
    // graph.tree = structure_tree(src);
  });

  const graph2 = document.createElement("script-graph2");
  const tr = new ActionHandler();
  window.tr = tr;
  tr.actions = src;
  tr.updateCallback = (actions) => {
    graph2.tree = tr.graph;
    fullcode.value = jsyaml.safeDump(tr.actions);
  };
  tr.selectCallback = (idx, action, update) => {
    graph2.tree = tr.graph;
    const code = document.querySelector("#snippet");
    code.value = jsyaml.safeDump(action);
    console.log(update);
    document.querySelector("#saveSnippet").onclick = () => update(jsyaml.safeLoad(code.value));
    document.querySelector("#deleteSnippet").onclick = () => update(jsyaml.safeLoad(null));
  }

  // graph2.tree = structure_tree2(src);
  graph2.tree = tr.graph;
  document.querySelector("#graph2").appendChild(graph2);

}
